class Node

# class Node | The `Node` interface is the primary datatype for the entire Document Object Model. More...
Full name | `DOM::Node`
Definition | `#include <dom_node.h>`
Inherited by | Attr, CDATASection, CharacterData, Comment, Document, DocumentFragment, DocumentType, Element, Entity, EntityReference, HTMLAnchorElement, HTMLAppletElement, HTMLAreaElement, HTMLBRElement, HTMLBaseElement, HTMLBaseFontElement, HTMLBlockquoteElement, HTMLBodyElement, HTMLButtonElement, HTMLDListElement, HTMLDirectoryElement, HTMLDivElement, HTMLDocument, HTMLElement, HTMLFieldSetElement, HTMLFontElement, HTMLFormElement, HTMLFrameElement, HTMLFrameSetElement, HTMLHRElement, HTMLHeadElement, HTMLHeadingElement, HTMLHtmlElement, HTMLIFrameElement, HTMLImageElement, HTMLInputElement, HTMLIsIndexElement, HTMLLIElement, HTMLLabelElement, HTMLLegendElement, HTMLLinkElement, HTMLMapElement, HTMLMenuElement, HTMLMetaElement, HTMLModElement, HTMLOListElement, HTMLObjectElement, HTMLOptGroupElement, HTMLOptionElement, HTMLParagraphElement, HTMLParamElement, HTMLPreElement, HTMLQuoteElement, HTMLScriptElement, HTMLSelectElement, HTMLStyleElement, HTMLTableCaptionElement, HTMLTableCellElement, HTMLTableColElement, HTMLTableElement, HTMLTableRowElement, HTMLTableSectionElement, HTMLTextAreaElement, HTMLTitleElement, HTMLUListElement, Notation, ProcessingInstruction, Text
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- enum NodeType { ELEMENT_NODE = 1, ATTRIBUTE_NODE = 2, TEXT_NODE = 3, CDATA_SECTION_NODE = 4, ENTITY_REFERENCE_NODE = 5, ENTITY_NODE = 6, PROCESSING_INSTRUCTION_NODE = 7, COMMENT_NODE = 8, DOCUMENT_NODE = 9, DOCUMENT_TYPE_NODE = 10, DOCUMENT_FRAGMENT_NODE = 11, NOTATION_NODE = 12 }

#### Public Methods

- Node ()
- Node (const Node &other)
- Node ( NodeImpl *_impl)
- Node & operator = (const Node &other)
- bool operator == (const Node &other)
- bool operator != (const Node &other)
- virtual ~Node ()
- DOMString nodeName () const
- DOMString nodeValue () const
- void setNodeValue ( const DOMString & )
- unsigned short nodeType () const
- Node parentNode () const
- NodeList childNodes () const
- Node firstChild () const
- Node lastChild () const
- Node previousSibling () const
- Node nextSibling () const
- NamedNodeMap attributes () const
- Document ownerDocument () const
- Node insertBefore ( const Node &newChild, const Node &refChild )
- Node replaceChild ( const Node &newChild, const Node &oldChild )
- Node removeChild ( const Node &oldChild )
- Node appendChild ( const Node &newChild )
- bool hasChildNodes ( )
- Node cloneNode ( bool deep )
- void normalize ( )
- bool isSupported ( const DOMString &feature, const DOMString &version ) const
- DOMString namespaceURI ( ) const
- DOMString prefix ( ) const
- void setPrefix (const DOMString &prefix )
- DOMString localName ( ) const
- bool hasAttributes ( )
- void addEventListener (const DOMString &type, EventListener *listener, const bool useCapture)
- void removeEventListener (const DOMString &type, EventListener *listener, bool useCapture)
- bool dispatchEvent (const Event &evt)
- Q_UINT32 elementId () const
- bool isNull () const
- NodeImpl * handle () const
- unsigned long index () const
- QString toHTML ()
- void applyChanges ()
- void getCursor (int offset, int &_x, int &_y, int &height)
- QRect getRect ()

#### Protected Members

- NodeImpl *impl

## Detailed Description

The `Node` interface is the primary datatype for the entire Document Object Model. It represents a single node in the document tree. While all objects implementing the `Node` interface expose methods for dealing with children, not all objects implementing the `Node` interface may have children. For example, `Text` nodes may not have children, and adding children to such nodes results in a `DOMException` being raised.

The attributes `nodeName` , `nodeValue` and `attributes` are included as a mechanism to get at node information without casting down to the specific derived interface. In cases where there is no obvious mapping of these attributes for a specific `nodeType` (e.g., `nodeValue` for an Element or `attributes` for a Comment), this returns `null` . Note that the specialized interfaces may contain additional and more convenient mechanisms to get and set the relevant information.

Node () | ### Node

Node (const Node &other) | ### Node

Node ( NodeImpl *_impl) | ### Node

Node & operator = (const Node &other) | ### operator =

bool operator == (const Node &other) | ### operator ==

bool operator != (const Node &other) | ### operator !=

~Node () | ### ~Node

[virtual]

enum NodeType { ELEMENT_NODE = 1, ATTRIBUTE_NODE = 2, TEXT_NODE = 3, CDATA_SECTION_NODE = 4, ENTITY_REFERENCE_NODE = 5, ENTITY_NODE = 6, PROCESSING_INSTRUCTION_NODE = 7, COMMENT_NODE = 8, DOCUMENT_NODE = 9, DOCUMENT_TYPE_NODE = 10, DOCUMENT_FRAGMENT_NODE = 11, NOTATION_NODE = 12 } | ### NodeType

An integer indicating which type of node this is.

The values of `nodeName`, `nodeValue`, and `attributes` vary according to the node type as follows:

| nodeName | nodeValue | attributes
Element | tagName | null | NamedNodeMap
Attr | name of attribute | value of attribute | null
Text | #text | content of the text node | null
CDATASection | #cdata-section | content of the CDATA Section | null
EntityReference | name of entity referenced | null | null
Entity | entity name | null | null
ProcessingInstruction | target | entire content excluding the target | null
Comment | #comment | content of the comment | null
Document | #document | null | null
DocumentType | document type name | null | null
DocumentFragment | #document-fragment | null | null
Notation | notation name | null | null

DOMString nodeName () | ### nodeName

[const]

The name of this node, depending on its type; see the table above.

DOMString nodeValue () | ### nodeValue

[const]

The value of this node, depending on its type; see the table above.

Throws: DOMException, DOMSTRING_SIZE_ERR:, Raised, when, it, would, return, more, characters, than, fit, in, a, `, DOMString,` , variable, on, the, implementation, platform.

void setNodeValue ( const DOMString & ) | ### setNodeValue

see nodeValue

Throws: DOMException, NO_MODIFICATION_ALLOWED_ERR:, Raised, when, the, node, is, readonly.

unsigned short nodeType () | ### nodeType

[const]

A code representing the type of the underlying object, as defined above.

Node parentNode () | ### parentNode

[const]

The parent of this node. All nodes, except `Document` , `DocumentFragment` , and `Attr` may have a parent. However, if a node has just been created and not yet added to the tree, or if it has been removed from the tree, this is `null` .

NodeList childNodes () | ### childNodes

[const]

A `NodeList` that contains all children of this node. If there are no children, this is a `NodeList` containing no nodes. The content of the returned `NodeList` is "live" in the sense that, for instance, changes to the children of the node object that it was created from are immediately reflected in the nodes returned by the `NodeList` accessors; it is not a static snapshot of the content of the node. This is true for every `NodeList` , including the ones returned by the `getElementsByTagName` method.

Node firstChild () | ### firstChild

[const]

The first child of this node. If there is no such node, this returns `null` .

Node lastChild () | ### lastChild

[const]

The last child of this node. If there is no such node, this returns `null` .

Node previousSibling () | ### previousSibling

[const]

The node immediately preceding this node. If there is no such node, this returns `null` .

Node nextSibling () | ### nextSibling

[const]

The node immediately following this node. If there is no such node, this returns `null` .

NamedNodeMap attributes () | ### attributes

[const]

A `NamedNodeMap` containing the attributes of this node (if it is an `Element` ) or `null` otherwise.

Document ownerDocument () | ### ownerDocument

[const]

The `Document` object associated with this node. This is also the `Document` object used to create new nodes. When this node is a `Document` this is `null` .

Node insertBefore ( const Node &newChild, const Node &refChild ) | ### insertBefore

Inserts the node `newChild` before the existing child node `refChild` . If `refChild` is `null` , insert `newChild` at the end of the list of children.

If `newChild` is a `DocumentFragment` object, all of its children are inserted, in the same order, before `refChild` . If the `newChild` is already in the tree, it is first removed.

WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.

NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

NOT_FOUND_ERR: Raised if `refChild` is not a child of this node.

Parameters:

newChild | The node to insert.
refChild | The reference node, i.e., the node before which the new node must be inserted.

Returns: The node being inserted.

Throws: DOMException, HIERARCHY_REQUEST_ERR:, Raised, if, this, node, is, of, a, type, that, does, not, allow, children, of, the, type, of, the, `, newChild,` , node, or, if, the, node, to, insert, is, one, of, this, node's, ancestors.

Node replaceChild ( const Node &newChild, const Node &oldChild ) | ### replaceChild

Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node. If the `newChild` is already in the tree, it is first removed.

WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.

NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

NOT_FOUND_ERR: Raised if `oldChild` is not a child of this node.

Parameters:

newChild | The new node to put in the child list.
oldChild | The node being replaced in the list.

Returns: The node replaced.

Throws: DOMException, HIERARCHY_REQUEST_ERR:, Raised, if, this, node, is, of, a, type, that, does, not, allow, children, of, the, type, of, the, `, newChild,` , node, or, it, the, node, to, put, in, is, one, of, this, node's, ancestors.

Node removeChild ( const Node &oldChild ) | ### removeChild

Removes the child node indicated by `oldChild` from the list of children, and returns it.

NOT_FOUND_ERR: Raised if `oldChild` is not a child of this node.

Parameters:

oldChild | The node being removed.

Returns: The node removed.

Throws: DOMException, NO_MODIFICATION_ALLOWED_ERR:, Raised, if, this, node, is, readonly.

Node appendChild ( const Node &newChild ) | ### appendChild

Adds the node `newChild` to the end of the list of children of this node. If the `newChild` is already in the tree, it is first removed.

If it is a `DocumentFragment` object, the entire contents of the document fragment are moved into the child list of this node

WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.

NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

Parameters:

newChild | The node to add.

Returns: The node added.

Throws: DOMException, HIERARCHY_REQUEST_ERR:, Raised, if, this, node, is, of, a, type, that, does, not, allow, children, of, the, type, of, the, `, newChild,` , node, or, if, the, node, to, append, is, one, of, this, node's, ancestors.

bool hasChildNodes ( ) | ### hasChildNodes

This is a convenience method to allow easy determination of whether a node has any children.

Returns: `true` if the node has any children, `false` if the node has no children.

Node cloneNode ( bool deep ) | ### cloneNode

Returns a duplicate of this node, i.e., serves as a generic copy constructor for nodes. The duplicate node has no parent ( `parentNode` returns `null` .).

Cloning an `Element` copies all attributes and their values, including those generated by the XML processor to represent defaulted attributes, but this method does not copy any text it contains unless it is a deep clone, since the text is contained in a child `Text` node. Cloning any other type of node simply returns a copy of this node.

Parameters:

deep | If `true` , recursively clone the subtree under the specified node; if `false` , clone only the node itself (and its attributes, if it is an `Element` ).

Returns: The duplicate node.

void normalize ( ) | ### normalize

Modified in DOM Level 2

Puts all Text nodes in the full depth of the sub-tree underneath this Node, including attribute nodes, into a "normal" form where only structure (e.g., elements, comments, processing instructions, CDATA sections, and entity references) separates Text nodes, i.e., there are neither adjacent Text nodes nor empty Text nodes. This can be used to ensure that the DOM view of a document is the same as if it were saved and re-loaded, and is useful when operations (such as XPointer [XPointer] lookups) that depend on a particular document tree structure are to be used.

Note: In cases where the document contains CDATASections, the normalize operation alone may not be sufficient, since XPointers do not differentiate between Text nodes and CDATASection nodes.

bool isSupported ( const DOMString &feature, const DOMString &version ) | ### isSupported

[const]

Introduced in DOM Level 2

Tests whether the DOM implementation implements a specific feature and that feature is supported by this node.

Parameters:

feature | The name of the feature to test. This is the same name which can be passed to the method hasFeature on DOMImplementation.
version | This is the version number of the feature to test. In Level 2, version 1, this is the string "2.0". If the version is not specified, supporting any version of the feature will cause the method to return true.

Returns: Returns true if the specified feature is supported on this node, false otherwise.

DOMString namespaceURI ( ) | ### namespaceURI

[const]

Introduced in DOM Level 2

The namespace URI of this node, or null if it is unspecified. This is not a computed value that is the result of a namespace lookup based on an examination of the namespace declarations in scope. It is merely the namespace URI given at creation time. For nodes of any type other than ELEMENT_NODE and ATTRIBUTE_NODE and nodes created with a DOM Level 1 method, such as createElement from the Document interface, this is always null.

Note: Per the Namespaces in XML Specification [Namespaces] an attribute does not inherit its namespace from the element it is attached to. If an attribute is not explicitly given a namespace, it simply has no namespace.

DOMString prefix ( ) | ### prefix

[const]

Introduced in DOM Level 2

The namespace prefix of this node, or null if it is unspecified. Note that setting this attribute, when permitted, changes the nodeName attribute, which holds the qualified name, as well as the tagName and name attributes of the Element and Attr interfaces, when applicable. Note also that changing the prefix of an attribute that is known to have a default value, does not make a new attribute with the default value and the original prefix appear, since the namespaceURI and localName do not change. For nodes of any type other than ELEMENT_NODE and ATTRIBUTE_NODE and nodes created with a DOM Level 1 method, such as createElement from the Document interface, this is always null.

void setPrefix (const DOMString &prefix ) | ### setPrefix

see prefix

NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

NAMESPACE_ERR: Raised if the specified prefix is malformed, if the namespaceURI of this node is null, if the specified prefix is "xml" and the namespaceURI of this node is different from "http://www.w3.org/XML/1998/namespace", if this node is an attribute and the specified prefix is "xmlns" and the namespaceURI of this node is different from "http://www.w3.org/2000/xmlns/", or if this node is an attribute and the qualifiedName of this node is "xmlns" [Namespaces].

Throws: DOMException, INVALID_CHARACTER_ERR:, Raised, if, the, specified, prefix, contains, an, illegal, character.

DOMString localName ( ) | ### localName

[const]

Introduced in DOM Level 2

Returns the local part of the qualified name of this node. For nodes of any type other than ELEMENT_NODE and ATTRIBUTE_NODE and nodes created with a DOM Level 1 method, such as createElement from the Document interface, this is always null.

bool hasAttributes ( ) | ### hasAttributes

Returns whether this node (if it is an element) has any attributes.

Returns: a boolean. True if this node has any attributes, false otherwise. Introduced in DOM Level 2

void addEventListener (const DOMString &type, EventListener *listener, const bool useCapture) | ### addEventListener

Introduced in DOM Level 2 This method is from the EventTarget interface

This method allows the registration of event listeners on the event target. If an EventListener is added to an EventTarget while it is processing an event, it will not be triggered by the current actions but may be triggered during a later stage of event flow, such as the bubbling phase.

If multiple identical EventListeners are registered on the same EventTarget with the same parameters the duplicate instances are discarded. They do not cause the EventListener to be called twice and since they are discarded they do not need to be removed with the removeEventListener method. Parameters

Parameters:

type | The event type for which the user is registering
listener | The listener parameter takes an interface implemented by the user which contains the methods to be called when the event occurs.
useCapture | If true, useCapture indicates that the user wishes to initiate capture. After initiating capture, all events of the specified type will be dispatched to the registered EventListener before being dispatched to any EventTargets beneath them in the tree. Events which are bubbling upward through the tree will not trigger an EventListener designated to use capture.

void removeEventListener (const DOMString &type, EventListener *listener, bool useCapture) | ### removeEventListener

Introduced in DOM Level 2 This method is from the EventTarget interface

This method allows the removal of event listeners from the event target. If an EventListener is removed from an EventTarget while it is processing an event, it will not be triggered by the current actions.

EventListeners can never be invoked after being removed.

Calling removeEventListener with arguments which do not identify any currently registered EventListener on the EventTarget has no effect.

Parameters:

type | Specifies the event type of the EventListener being removed.
listener | The EventListener parameter indicates the EventListener to be removed.
useCapture | Specifies whether the EventListener being removed was registered as a capturing listener or not. If a listener was registered twice, one with capture and one without, each must be removed separately. Removal of a capturing listener does not affect a non-capturing version of the same listener, and vice versa.

bool dispatchEvent (const Event &evt) | ### dispatchEvent

Introduced in DOM Level 2 This method is from the EventTarget interface

This method allows the dispatch of events into the implementations event model. Events dispatched in this manner will have the same capturing and bubbling behavior as events dispatched directly by the implementation. The target of the event is the EventTarget on which dispatchEvent is called.

Parameters:

evt | Specifies the event type, behavior, and contextual information to be used in processing the event.

Returns: The return value of dispatchEvent indicates whether any of the listeners which handled the event called preventDefault. If preventDefault was called the value is false, else the value is true.

Throws: EventException, UNSPECIFIED_EVENT_TYPE_ERR:, Raised, if, the, Event's, type, was, not, specified, by, initializing, the, event, before, dispatchEvent, was, called., Specification, of, the, Event's, type, as, null, or, an, empty, string, will, also, trigger, this, exception.

Q_UINT32 elementId () | ### elementId

[const]

not part of the DOM.

Returns: the element id, in case this is an element, 0 otherwise

bool isNull () | ### isNull

[const]

tests if this Node is 0. Useful especially, if casting to a derived class:

     Node n = .....;
     // try to convert into an Element:
     Element e = n;
     if( e.isNull() )
       kdDebug(300) << "node isn't an element node" << endl;

NodeImpl * handle () | ### handle

[const]

unsigned long index () | ### index

[const]

QString toHTML () | ### toHTML

void applyChanges () | ### applyChanges

void getCursor (int offset, int &_x, int &_y, int &height) | ### getCursor

QRect getRect () | ### getRect

not part of the DOM.

Returns: the exact coordinates and size of this element.

NodeImpl * impl | ### impl

[protected]

Generated by: root on macppc.ports.openbsd.org on Sat Sep 6 10:37:43 2003, using kdoc 2.0a54.